#include "callback.h"
#include "intl.h"
#include "log.h"

bool callback_install(lm_ctx_t *ctx, lm_pkg_t *pkg, char *file, size_t current, size_t total, void *data) {
  bar(current, total);
  return true;
}

bool callback_download(lm_ctx_t *ctx, lm_pkg_t *pkg, bool is_archive, size_t current, size_t total, void *data) {
  if (is_archive)
    bar(current, total);
  return true;
}

bool callback_remove(lm_ctx_t *ctx, lm_entry_t *ent, char *file, size_t current, size_t total, void *data) {
  bar(current, total);
  return true;
}

bool callback_sync(
    lm_ctx_t *ctx, lm_pool_t *pool, lm_ctx_sync_state_t state, size_t current, size_t total, void *data) {
  switch (state) {
  case SYNC_DOWNLOADING_INFO:
    bar(current, total);
    break;

  case SYNC_INFO_SUCCESS:
    bar_free();
    break;

  case SYNC_INFO_FAIL:
    bar_free();
    error(_("Failed to sync " FG_BOLD "%s" FG_RESET ": %s"), pool->name, lm_strerror());
    break;

  case SYNC_DOWNLOADING_LIST:
    bar(current, total);
    break;

  case SYNC_LIST_SUCCESS:
    bar_free();
    success(_("Synced " FG_BOLD "%s [%s]" FG_RESET), pool->name, pool->info.pubkey);
    break;

  case SYNC_LIST_FAIL:
    bar_free();
    if (LM_ERR_InfoNotLoaded != lm_error())
      error(_("Failed to sync " FG_BOLD "%s" FG_RESET ": %s"), pool->name, lm_strerror());
    break;
  }

  return true;
}
