#include <libmp/all.h>
#include <stdio.h>

#include "../callback.h"
#include "../intl.h"
#include "../cmd.h"
#include "../log.h"

bool cmd_sync(lm_ctx_t *ctx, config_t *config, args_t *args){
  size_t sycned = 0;
  bool ret = false;
  char *arg = NULL;
  
  if((arg = args_register_check(args)) != NULL){
    error(_("Unknown argument: "FG_BOLD"--%s"FG_RESET", run with "FG_BOLD"--help"FG_RESET" to list the avaliable arguments"), arg);
    return false;
  }

  if(config->pool_count == 0){
    error(_("There are no pools specified in the configuration"));
    goto end;
  }

  sycned = lm_ctx_sync(ctx, true, callback_sync, NULL);
  bar_free();

  if(sycned < 0){
    error(_("Failed to sync pools: %s"), lm_strerror());
    goto end;
  }

  info(_("Synced "FG_BOLD"%d"FG_RESET"/"FG_BOLD"%d"FG_RESET" pools"), sycned, config->pool_count);
  ret = true;

end:
  bar_free();
  return ret;
}
